package gregapi.tileentity;

import gregapi.code.TagData;
import gregapi.data.TD;
import ic2.api.energy.tile.IEnergySink;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.util.ForgeDirection;
import cofh.api.energy.IEnergyReceiver;

/**
 * @author Gregorius Techneticies
 * 
 * For Internal Use.
 */
public class EnergyCompat {
	private static boolean RF_ENERGY = false, IC_ENERGY = false, CHECK_ALL = true;
	
	private static void checkAvailabilities() {
		if (CHECK_ALL) {
			try {
				IEnergyReceiver.class.getCanonicalName();
				RF_ENERGY = true;
			} catch(Throwable e) {/**/}
			try {
				IEnergySink.class.getCanonicalName();
				IC_ENERGY = true;
			} catch(Throwable e) {/**/}
			CHECK_ALL = false;
		}
	}
	
	public static long insertEnergyInto(TagData aEnergyType, byte aSideInto, long aSize, long aAmount, Object aEmitter, TileEntity aReceiver) {
		long rUsedAmount = 0;
		checkAvailabilities();
		if (IC_ENERGY && aEnergyType == TD.Energy.ELECTRICITY && aReceiver instanceof IEnergySink) {
    		if (((IEnergySink)aReceiver).acceptsEnergyFrom(aEmitter instanceof TileEntity ? (TileEntity)aEmitter : null, ForgeDirection.getOrientation(aSideInto))) {
    			while (aAmount > rUsedAmount && ((IEnergySink)aReceiver).getDemandedEnergy() > 0 && ((IEnergySink)aReceiver).injectEnergy(ForgeDirection.getOrientation(aSideInto), aSize, aSize) < aSize) rUsedAmount++;
    		}
		} else if (RF_ENERGY && aEnergyType == TD.Energy.REDSTONE_FLUX && aReceiver instanceof IEnergyReceiver && ((IEnergyReceiver)aReceiver).canConnectEnergy(ForgeDirection.getOrientation(aSideInto))) {
			rUsedAmount+=((IEnergyReceiver)aReceiver).receiveEnergy(ForgeDirection.getOrientation(aSideInto), (int)aAmount, false);
		}
		return rUsedAmount;
	}
}