package gregapi.tileentity;

/**
 * @author Gregorius Techneticies
 * 
 * Implemented by the MultiTileEntity Chest example. If this is not implemented, I will go for the regular Collision Box, but that is much laggier.
 */
public interface ITileEntitySurface {
	/** How "Fat" a visual Pipe can be at max when connecting. 1.0F for Full Blocks, 0.5F for 1/4th of a Block (so with half height and half width) */
	public float getSurfaceSize(byte aSide);
	/** How deep a Pipe has to go into the Block in order to visually connect to a Surface on that Side. 0.0F for Full Blocks, 0.5F for going to the middle of the Block, 1.0F for going through the whole Block (even though the last should not be the case most of the time) */
	public float getSurfaceDistance(byte aSide);
	/** If this Side is Solid, like a facing of a full Block. It CAN still be transparent like a Block of Glass. */
	public boolean isSurfaceSolid(byte aSide);
	/** If this Side is Opaque, like a facing of a full and non-transparent Block. */
	public boolean isSurfaceOpaque(byte aSide);
}